uses dos,  crt;

var
   grdriver,
   grmode,
   i : integer;
   sine : array [0..359] of real;
   cosine : array [0..359] of real;
   ch : char;

PROCEDURE Line(x1,y1,x2,y2:Integer; col:Byte);
VAR Angel      : Real;
    RAngel     : Real;
    i          : Integer;
    DifX, DifY : Integer;
BEGIN
  IF x1=x2 THEN
  BEGIN
    IF y2>=y1 THEN FOR i:=y1 TO y2 DO Mem[$a000:x1+i*320]:=col;
    IF y1>y2 THEN FOR i := y2 TO y1 DO Mem[$a000:x1+i*320]:=col;
    Exit;
  END;

  IF y1=y2 THEN
  BEGIN
    IF x1<x2 THEN FOR i:=x1 TO x2 DO Mem[$a000:i+y1*320]:=col;
    IF x1>=x2 THEN FOR i:=x2 TO x1 DO Mem[$a000:i+y1*320]:=col;
    Exit;
  END;

  Angel:=(y1-y2)/(x1-x2);
  DifX:=Abs(x1-x2);
  DifY:=Abs(y1-y2);

  IF DifX<=DifY THEN
  BEGIN
    IF y1>y2 THEN
    BEGIN
      y1:=y2;
      x1:=x2;
    END;
    RAngel:=1/Angel;
    FOR i:=0 TO DifY DO Mem[$a000:(Trunc(i*RAngel)+x1)+(i+y1)*320]:=Col;
  END
  ELSE
  BEGIN
    IF x1>x2 THEN
    BEGIN
      x1:=x2;
      y1:=y2;
    END;
    FOR i := 0 TO DifX DO Mem[$a000:i + x1+(Trunc(Angel*i)+y1)*320]:=Col;
  END;
END;


begin
     ASM Mov ax,13h; Int 10h; END;
     {Remake sin table for quicker math}
     for i := 0 to 359 do
     begin
          sine [i] := sin (i*0.05);
          cosine [i] := cos (i*0.05);
     end;
     {reset vars}
     ch := #0;
     i := 0;
     repeat
    {draw white square from 4 point that orbit 50 pixel from center}
     line (round (120+50*sine[i]),round(100+50*cosine[i]),
     round (120+50*sine[i+90]),round(100+50*cosine[i+90]),15);
     line (round (120+50*sine[i+90]),round(100+50*cosine[i+90]),
     round (120-50*sine[i]),round(100-50*cosine[i]),15);
     line (round (120+50*sine[i]),round(100+50*cosine[i]),
     round (120-50*sine[i+90]),round(100-50*cosine[i+90]),15);
     line (round (120-50*sine[i+90]),round(100-50*cosine[i+90]),
     round (120-50*sine[i]),round(100-50*cosine[i]),15);
     delay (100);
     {erase}
     line (round (120+50*sine[i]),round(100+50*cosine[i]),
     round (120+50*sine[i+90]),round(100+50*cosine[i+90]),0);
     line (round (120+50*sine[i+90]),round(100+50*cosine[i+90]),
     round (120-50*sine[i]),round(100-50*cosine[i]),0);
     line (round (120+50*sine[i]),round(100+50*cosine[i]),
     round (120-50*sine[i+90]),round(100-50*cosine[i+90]),0);
     line (round (120-50*sine[i+90]),round(100-50*cosine[i+90]),
     round (120-50*sine[i]),round(100-50*cosine[i]),0);
     inc (i);
     if i > 160 then
     i := 0;
     if keypressed then
     ch := readkey;
     until ch = #27;
     asm mov ax,3h; int 10h; END;;
end.
